<?php
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.model' );


class revexshopModelRevexshop extends JModelList
{
	function __construct(){
		parent::__construct();

	}
  
  var $_data;


////////////////////////////////////////////////////////////////////////////////
//Virtuemart vizsgálat
  function checkvm ()
  {
    $db = JFactory::getDbo();
    $prefix=$db->getPrefix();
    $tables = $db->getTableList();
    $vmtabla=$prefix."virtuemart_orderstates";

    if (in_array($vmtabla, $tables)){
      $vmcheck = 2;
    } else {
      $vmcheck = 0;
    }
    return $vmcheck;
  }

////////////////////////////////////////////////////////////////////////////////

function revbackup ($path) {

    $db = JFactory::getDbo();
    $prefix=$db->getPrefix();
    $backtable=$prefix."revexshopbackup";
    
    $db->dropTable($backtable, true);
    
    $query = "CREATE TABLE $backtable (order_number char (64) collate utf8_general_ci, megrendelt char (1) NOT NULL DEFAULT 0, revoldate INT (12) NOT NULL DEFAULT 0, PRIMARY KEY (order_number))";
    $db->setQuery($query);
    $db->execute();

    $query = "INSERT INTO $backtable (`order_number`, `megrendelt`, `revoldate`) SELECT vm.order_number, vm.megrendelt, vm.revoldate FROM $path vm";
    $db->setQuery($query);
    $db->execute();
}

////////////////////////////////////////////////////////////////////////////////

function revrestore ($path) {

    $db = JFactory::getDbo();
    $prefix=$db->getPrefix();
    $backtable=$prefix."revexshopbackup";

      $query = "UPDATE $path LEFT JOIN $backtable ON $path.order_number = $backtable.order_number SET $path.megrendelt=$backtable.megrendelt, $path.revoldate=$backtable.revoldate";

      $db->setQuery($query);
      $db->execute();

}

////////////////////////////////////////////////////////////////////////////////
//Dátumvizsgálat
  function is_date( $str ) 
  { 
    if ($str == '0') {
      $stamp = '1';
      return $stamp;
      
    } else if ($str == '1') {
      $stamp = '2';
      return $stamp;
      
    } else {
   
    $stamp = strtotime( $str ); 
      
    if (!is_numeric($stamp)) 
    { 
       return false; 
    } 
    $month = date( 'm', $stamp ); 
    $day   = date( 'd', $stamp ); 
    $year  = date( 'Y', $stamp ); 
    
    if (checkdate($month, $day, $year)) 
    { 
       return $stamp; 
    } 
    }
  }

////////////////////////////////////////////////////////////////////////////////
//A beírt adatok letárolása az adatbázisba  
  function store()
  	{

      jimport('joomla.filesystem.folder');
      $db = JFactory::getDbo();
      $prefix=$db->getPrefix();
      $tablanev=$prefix."revexshop";
      $novm = "Virtuemart nincs telepítve vagy nem kompatibilis";
      
    //Virtuemart verzió ellenőrzése  
      $vmcheck = $this->checkvm();


      
      switch($vmcheck)
      {
      case "0":
        return $novm;
        break;

      case "2":
        $vmtable=$prefix."virtuemart_orders";
        $shorttable = "#__virtuemart_orders";
        break;

      default:
        return $novm;                  
        break;                  
      }   

    // Megvannak-e a mezők a letöltéshez?
      $query = "SELECT * FROM $shorttable";
      $db->setQuery($query);
      $result = $db->loadAssoc();

      if ($result && (!isset($result['megrendelt']) || !isset($result['revoldate']))) {
        if (!isset($result['megrendelt'])) {
        $query = "ALTER TABLE $shorttable ADD COLUMN megrendelt char (1) NOT NULL DEFAULT 0";
        $db->setQuery( $query );
        $result = $db->execute();
        }

        if (!isset($result['revoldate'])) {
        $query = "ALTER TABLE $shorttable ADD COLUMN revoldate int (12) NOT NULL DEFAULT 0";
        $db->setQuery( $query );
        $result = $db->execute();
        }
        $this->revrestore($shorttable);
      }



    //Saját tábla paramétereinek ellenőrzése és létrehozása
      $query = "SELECT * FROM $tablanev";
      $db->setQuery($query);
      $db->execute();
      $num_rows = $db->getNumRows();
      $result = $db->loadAssoc();
      $beirtnev = $result['nev'];
      $md5beirtnev = md5($beirtnev);
      $path = JPATH_SITE .'/'.$md5beirtnev;
     
      if ( JFolder::exists($path)) {
         JFolder::delete($path);
          } 

      //Ha nincs ilyen, törölje a táblát és hozza létre újra
      if ($num_rows != 1){
        if ($num_rows > 1){

            $db->dropTable($tablanev, true);

            $query = "CREATE TABLE $tablanev (id INT NOT NULL AUTO_INCREMENT, PRIMARY KEY (id), progkod VARCHAR (32), nev VARCHAR (6))";
            $db->setQuery( $query );
            $db->execute();

            $query = "INSERT INTO $tablanev (progkod, nev) VALUES ('','')";
            $db->setQuery( $query );
            $db->execute();

        } else if ($num_rows < 1){

            $query = "INSERT INTO $tablanev (progkod, nev) VALUES ('','')";
            $db->setQuery( $query );
            $db->execute();

        }

        $query = "SELECT * FROM $tablanev";
        $db->setQuery($query);
        $result = $db->loadAssoc();

       }

      //Adatok beállítása táblában
      $row = $this->getTable();

      //Bejönnek az adatok
      $data = JFactory::getApplication()->input->post->getArray();

      //Egy kis szűrés
      $data['progkod'] = preg_replace('/[^A-Za-z0-9]/', '', $data['progkod']);
      $data['nev'] = preg_replace('/[^A-Za-z0-9]/', '', $data['nev']);
      $data['id'] = $result['id'];


      //Hibaellenőrzés a kapott adatokkal
      //Ha a generált kód nem 32 hosszú
      if (strlen($data['progkod']) != 32) {
  			$this->setError($this->_db->getErrorMsg());
  			return false;
  		}
      
      //Ha a keretkód nem 6 hosszú
      if (strlen($data['nev']) != 6) {
  			$this->setError($this->_db->getErrorMsg());
  			return false;
  		}

  		// Bind the form fields to the table
  		if (!$row->bind($data)) {
  			$this->setError($this->_db->getErrorMsg());
  			return false;
  		}
  
  		// Make sure the record is valid
  		if (!$row->check()) {
  			$this->setError($this->_db->getErrorMsg());
  			return false;
  		}
       
  		// Store the web link table to the database
  		if (!$row->store()) {
  			$this->setError( $row->getErrorMsg() );
  			return false;
  		}
  		return true;
  	}




////////////////////////////////////////////////////////////////////////////////
function trashrun() {

      $db = JFactory::getDbo();
      $prefix=$db->getPrefix();
      $novm = "Virtuemart nincs telepítve vagy nem kompatibilis";
      
    //Virtuemart verzió ellenőrzése  
      $vmcheck = $this->checkvm();
     
      switch($vmcheck)
      {
       case "0":
        return false;
        break;
        
      case "2":
        $vmtable=$prefix."virtuemart_orders";
        $create="created_on";
        break;

      default:
        return false;                  
        break;                  
      }

      $query = "SELECT * FROM $vmtable";
      $db->setQuery($query);
      $db->execute();
      $num_rows = $db->getNumRows();

      if($num_rows < 1) {
        $noorder = 999;
        return $noorder;
      }


    //Lekérjük a postolt adatokat 
      $data = JFactory::getApplication()->input->post->getArray();
      $trash = $data['trash'];
      
      $patterns = array('/[A-Za-z]/','/\//', '/\^/', '/\./', '/\:/','/\$/', '/\|/', '/\-/','/\(/', '/\)/', '/\[/', '/\]/', '/\*/', '/\+/','/\?/', '/\{/', '/\}/', '/\,/');
      $trash = preg_replace($patterns, "$1/$2", $trash);
    

    //Dátum kinyerése
      $is_date = $this->is_date($trash);

      if (!$is_date) {
        return false;
      }
      
      $this->revrestore($vmtable);
      
      $query = "UPDATE $vmtable SET megrendelt =";

      if ($is_date == '1') {
    //Töröljük az összes állapotot, dátumtól függetlenül
      $query .= " 0";
      $db->setQuery($query);
      $db->execute();
      } elseif ($is_date == '2') {
    //Beállítjuk az összes állapotot nullára, ahol nem nulla a dátum
      $query .= " 1 WHERE revoldate <> 0 AND megrendelt = 0";
      $db->setQuery($query);
      $db->execute();
      } else {
          if ($vmcheck == "2"){
          $is_date = date("Y-m-d H:i:s", $is_date );
          $is_date= "'".$is_date."'";
          }
     //A beírt dátumtól újabbaknál töröljük az állapotot 
      $query .= " 0 WHERE $create >= $is_date";
      $db->setQuery($query);
      $db->execute();
      }
      
      $this->revbackup($vmtable);
       
      return true;
  }
////////////////////////////////////////////////////////////////////////////////
 
}
?>